;============================================
;                  
; óοоƬ¶
; м򵥵Ĺܲԡд©о
; Ƽ޹˾Դ˲еκΡ
;   (C)Shenzhen Chipsea Technologies Co.,Ltd
;============================================
; filename: 3218.asm
; chip    : CSU8RP3218
; author  :
; date    : 2017-06-14
; clk=4 Mhz
; v1.0

;IO:
;pt1.4LED0				pt5.0pwm2
;pt1.5ѹȼʾLED1		pt3.5pwm3pwm3L                  
;pt3.1ѹѹ			pt3.6pwm3pwm3H
;pt3.2ѹȼʾLED2		pt3.0UARTָʾLED3 
;pt3.3: UARTݽտ			pt3.4UARTݷͿ

;˵
;1ʱ04msĶʱжϣ
;2pt1.4LED0ÿ˸һ;
;3pt3.1ķѹѹADⷶΧ	2.2V(2/3VDD)~3.3V(VDD)
;	ʹݲȽϱֵ͵ѹADֵĴС
;	ѹΪ	2.2V~2.5V LED1,LED2;
;					2.5V~2.9V LED1,LED2;
;					2.9V~3.3V LED1,LED2;
;4pt5.0pwm2ʱƵΪ4kHz,ÿһη;
;		 pwm3LʱƵΪ200kHz;
;5pt3.3&pt3.4UARTݷͿںͽտաԵԵķһ֡ݣ
; 		֡Ϊ0DHʱMCUл״̬Է֡ݣ
; 		 "Hi" ASCֱΪ48H69HLED3200msϨ
;============================================
include "CSU8RP3218.inc"
include "define_const.inc"					; ݱλ 
include "macro.inc"								; תƺ궨 
;============================================
; program start
;============================================ 
	org		00h
	goto	Reset
	org		004h
	goto	INT_FUNCTION

;============================================
; ʼεһֶ巽ʽ
;============================================
//CSCC_RES_VECT   .section rom,addr=0x00   
//	goto     Reset      	; go to main program
//.ends
	
//CSCC_INT_VECT	.section rom,addr=0x04 
//    goto     INT_FUNCTION		; go to interrupt function
//.ends
;==============================================================
;  ʼ
;==============================================================
Reset:
	clrwdt								;忴Ź
	call	DELAY	  	    			;ϵʱ               	
	call	Pro_Sys_Init	  			;ϵͳϵʼ			                           		
	goto	Main      	  				;
		                    			         
;==============================================================	
;  ѭ
;==============================================================	
Main:
   clrwdt								;忴Ź
   call		Pro_Check_Voltage			;ѹ
   call		Pro_Open_Pwm				;pwm
   call 	Pro_Uart					;ͺͽUART   
   call		Pro_Sleep					;߳
   
   goto     Main

;==============================================================	
;  ѹ
;==============================================================	
Pro_Check_Voltage:
if		IF_ADC
	movlw	10000000b
	movwf	SRADCON1					;VDDΪοѹ                             
	movlw	00010000b                                                                  
	movwf	SRADCON2					;pt3.1(AIN1)ΪADCͨ                  
	movlw	00000010b					                                               
	movwf	PT3CON						;pt3.1Ϊģ                           
else 		                                                                           
	movlw	10000000b                                                                  
	movwf	SRADCON1					;VDDΪοѹ                             
	movlw	10100000b                                                                  
	movwf	SRADCON2					;ڲοѹ(AIN10)ΪADCͨòοѹС           										                                               
	clrf	PT3CON						;ڲADC 
	endif                                                                              
	                                                                 
	call	Sub_ADC_Value				;ADCӳ                                               
	                                                                                   
	movfw	R_Adc_Value_L               ;ȡɼADֵĵλ                              
	movwf	R_Voltage_L                                                                
	movfw	R_Adc_Value_H               ;ȡɼADֵĸλ                              
	movwf	R_Voltage_H                                                                
                                                                                       
Sub_Read_Tab1:                                                                         
	movlw	LOW TabStartAddr                                                                         
	movwf	R_Tabaddr_L                 ;ַ1                                      
	movlw	HIGH TabStartAddr                                                                         
	movwf	R_Tabaddr_H                                                              
		                                                                               
	movfw	R_Tabaddr_L                                                                
	movwf	EADRL                       ;ַĴ                                
	movfw	R_Tabaddr_H                                                                
	movwf	EADRH                                                                      
	movp								;ݵַһֵ                          
	nop                                                                                
	subwf	R_Voltage_L,0               ;Ƚ϶һֵADֵĴС                
	movfw	EDATH                                                                      
	subwfc	R_Voltage_H,0                                                              
	                                                                                   
	btfsc	STATUS,C                                                                  
	goto	Sub_Read_Tab2               ;ADֵȽADֵһֵĴС      
	                                                                               
Sub_AdcStation1:	                                                                                               
	clrf	R_AdcStation2_Cnt           ;ADֵСled1,led2ָʾ                   
	clrf 	R_AdcStation3_Cnt                                                          
	incf	R_AdcStation1_Cnt,1			;˲                                      
	movlw	20                          ;20ADֵȵһֵСصled1led2    
	subwf	R_AdcStation1_Cnt,0                                                        
	btfss	STATUS,C                                                                    
	goto	Sub_Check_Voltage_Exit                                                     
	clrf	R_AdcStation1_Cnt                                                          
	bcf		pt1_led1                    ;led1led2                                  
	bcf		pt3_led2                                                                   
	goto	Sub_Check_Voltage_Exit                                                     
	                                                                                   
Sub_Read_Tab2:                                                                         
	movlw	01h                                                                        
	addwf	R_Tabaddr_L,1               ;ַ1                                   
	movlw	00h                                                                        
	addwfc	R_Tabaddr_H,1                                                              
	movfw	R_Tabaddr_L                                                                
	movwf	EADRL                                                                      
	movfw	R_Tabaddr_H                                                                
	movwf	EADRH	                                                                   
	movp								;ڶֵ                                  
	nop                                                                                
	subwf	R_Voltage_L,0               ;ȽϵڶֵADֵĴС                    
	movfw	EDATH                                                                      
	subwfc	R_Voltage_H,0                                                              
	btfsc	STATUS,C                                                                    
	goto	Sub_AdcStation3             ;ADֵled2                              
	                                                                                   
Sub_AdcStation2:                        ;ADֵСled1                              
	clrf	R_AdcStation1_Cnt                                                          
	clrf	R_AdcStation3_Cnt                                                          
	incf	R_AdcStation2_Cnt,1			;˲                                      
	movlw	10                                                                         
	subwf	R_AdcStation2_Cnt,0                                                        
	btfss	STATUS,C                                                                    
	goto	Sub_Check_Voltage_Exit                                                     
	                                                                                   
	clrf	R_AdcStation2_Cnt	                                                       
	bsf		pt1_led1                    ;led1led2                                
	bcf		pt3_led2                                                                   
	goto	Sub_Check_Voltage_Exit                                                     
	                                                                                   
Sub_AdcStation3:                                                                       
	clrf	R_AdcStation1_Cnt                                                          
	clrf	R_AdcStation2_Cnt                                                          
	incf	R_AdcStation3_Cnt,1			;˲                                      
	movlw	10                                                                         
	subwf	R_AdcStation3_Cnt,0                                                        
	btfss	STATUS,C                                                                   
	goto	Sub_Check_Voltage_Exit                                                     
	                                                                                   
	clrf	R_AdcStation3_Cnt	                                                       
	bcf		pt1_led1                    ;led2led1                                
	bsf		pt3_led2                                                                   
	goto	Sub_Check_Voltage_Exit                                                 
                                                                                   
Sub_Check_Voltage_Exit:
	return
;==============================================================	
;  ADC
;==============================================================	
Sub_ADC_Value:
	call	Delay_10us					;ADתǰʱ10us
	clrf 	R_Adc_Value_L              	
	clrf 	R_Adc_Value_H             	;ADCݵĸߵλĴ
	clrf 	R_Adc_Cnt                  	;Ĵ
	bcf 	SRADCON1,OFFEX				;offset 
	             
Sub_Collect_Adc:                
	bsf 	SRADCON1,SRADS 				;ʼAD ת
	nop
Sub_Wait_Adc:                 
	btfsc 	SRADCON1,SRADS            
	goto 	Sub_Wait_Adc				;ȴAD ת
	movlw 	00000100b                 
	xorwf 	SRADCON1,1 					;offset    
	
Sub_Adc_Sum:                    
	incf 	R_Adc_Cnt,1                 ;ۼӰ˴μ   
	movfw 	SRADL                                       
    addwf 	R_Adc_Value_L,1             ;ۼӲɼADֵ 
    movfw 	SRADH                     
    andlw 	00001111b                 
	addwfc 	R_Adc_Value_H,1 			;ȡ12 λ ADC 
    btfss 	R_Adc_Cnt,3                 ;˴ADC֮      
	goto 	Sub_Collect_Adc        
	            
Sub_Adc_Average: 						;ADC ˴ƽ    
	movlf 	3,R_temp1                         
Sub_Average_Loop:                      
	bcf 	STATUS,C                            
	rrf	 	R_Adc_Value_H,1             ;սR_AdC_Value_L(λ)&        
	rrf 	R_Adc_Value_L,1          	;			 R_AdC_Value_H(λ)Ĵ          
	decfsz 	R_temp1,1                        
	goto 	Sub_Average_Loop 
	                 
	return                                  
;==============================================================	
;  pwm
;==============================================================		
Pro_Open_Pwm:
if		IF_PWM							;ָIF_PWMΪ1ʱִelseǰĳ
										;				IF_PWMΪ0ʱִelseĳ
	btfsc	R_flag,B_pwm3				;pwm3ֻܿһΣԱ֤pwmεȶB_pwm3                                          
    goto	Sub_Pwm_Exit                ;		Ϊ1˵Ѿpwm򲻲ֱ˳                                                  
    bsf		R_flag,B_pwm3                                                    
                                                                             
	clrf	TM3CON                                                          
    clrf    TM3RH;                                                           
    clrf    TM3INH;                                                           
                                                                             
	movlw	CONST_PWM3_TMIN				;79,Ƶ200kHz	                     
	movwf	TM3IN                                                            
	movlw	CONST_PWM3_TMR				;20,ռձ	                         
	movwf	TM3R                    	                                     
                                                                             
;	movlw	00000100b	 		                                             
;	movwf	tmcon2 		 				;ʱ3ʱѡ MCK  =16M           
		                                                                     
	movlw	00100111b					;ʱ 250ns  4*(1/16m)= 250ns	
	movwf	TM3CON2		            	;pwm3                             
	movlw	10000000b               	                                        
	movwf	TM3CON						;PWM3                            
                                                                             
	clrf 	R_10s1                                                           
    goto	Sub_Pwm_Exit                                                     
                                                                             
Sub_Pwm_Exit:	                                                             
	return	                                                                 
	                                                                         
else                                                                         
	btfss	R_flag,B_Time1             	;жB_Time1λ                                                                            
	goto	Sub_Close_pwm2             	;Ϊpwm2                                                                             
	                                   	                                                                                          
	btfsc	R_flag,B_pwm2              	;Ϊpwm2                                                                             
	goto	Sub_Pwm_Exit               	;pwm2ֻܿһΣԱ֤pwmεȶB_pwm2                                      
                                       	;		Ϊ1˵Ѿpwm򲻲ֱ˳    
    bsf		R_flag,B_pwm2                                                                                                                             
    clrf    TM2CON                                                           
    clrf    TM2RH                                                            
    clrf    TM2INH                                                           
                                                                             
	movlw	CONST_PWM2_TMIN				;249,Ƶ4kHz	                     
	movwf	TM2IN                   	                                     
	movlw	CONST_PWM2_TMR				;100,ռձ	                         
	movwf	TM2R                    	                                     
		                            	                                     
	movlw	10100011B					                                     
    movwf	TM2CON              		;PWM2	                     
                                    	                                     
    goto	Sub_Pwm_Exit            	                                     
                                    	                                     
Sub_Close_pwm2:                     	                                     
	clrf	TM2CON                  	;pwm2                                        
    clrf    TM2R                                                             
    clrf    TM2IN                                                            
    bcf		R_flag,B_pwm2                                                    
	                                                                         
Sub_Pwm_Exit:	                                                             
	return	                                                                 
	                                                                         
	endif 	                                                                 
;==============================================================	
;  ͺͽUART                                                    
;==============================================================	
Pro_Uart:
	btfsc		R_flag,B_send_ok		;жǷݣʱָʾ
	goto 		Send_Ok
	clrf		R_200ms_cnt				;200msʱ

	bcf	   		INTF3,URRIF				;ÿνջ֮ǰ־λ
	bsf	   		INTE3,URRIE				;ʹUARTж
	btfss		R_flag,B_urr			;ж޽жϣձ־λ򷵻
	goto		Sub_Uart_Exit
	
	bcf			R_flag,B_urr
	movfw		SBUF					;жϽյǷΪ0DH巢жϱ־λ򷵻
	xorlw		0dh
	btfss		STATUS,Z
	goto		Sub_Uart_Exit
	
	bcf	   		INTF3,URTIF
	bsf	   		INTE3,URTIE				;ʹܷжϱ־λ
	movlw		48h						;͵һ
	movwf		SBUF
	btfss		R_flag,B_urt
	goto		$-1
	bcf	    	INTF3,URTIF
	bsf	    	INTE3,URTIE
	bcf			R_flag,B_urt
	movlw		69h						;͵ڶ
	movwf		SBUF
	btfss		R_flag,B_urt
	goto		$-1
	bcf			R_flag,B_urt			;ʱ巢ͱ־λ
	bcf 		INTE3,URTIE				;طжʹλ
	bsf 		R_flag,B_send_ok		;÷ɱ־
	clrf		R_200ms_cnt				;200msʱ
	bcf			R_flag,B_200ms			;ʱ200msı־
	bsf			pt3_led3				;LED3ʱ200MS
Send_Ok:	
	btfss		R_flag,B_200ms			;ж200msʱǷ	
	goto 		Sub_Uart_Exit
	
	bcf			R_flag,B_200ms			;ʱ200msı־
	bcf			pt3_led3				;ʱLED3
	bcf			R_flag,B_send_ok		;ѷɱ־㣬һշ 		
Sub_Uart_Exit:	
	return	
;==============================================================	
;  SLEEP
;==============================================================	
Pro_Sleep:
	btfss	R_flag,B_Sleep				;жSleep־
	goto 	Sub_Sleep_Exit      		

	bcf		R_flag,B_Sleep
	movlw	00000000B           		
	movwf	INTE						;ȹصжʹ
	                            		
	clrf 	SRADCON1            		
	clrf 	SRADCON2					;ADCģ
	                            		
	clrf 	PT1                 		
	movlw	11110111b           		
	movwf	PT1EN						;pt1.3
	movlw	00001000b           		
	movwf	PT1PU						; I/O
	movlw	00010001b           		
	movwf	PT1CON						;ⲿж1ⲿж0
	
    clrf 	PT3     
    movlw 	11111111b
    movwf 	PT3EN   
    clrf 	PT3PU    
    movlw 	00000000b
    movwf 	PT3CON   
    
    clrf 	PT5      
    movlw 	11111111b
    movwf 	PT5EN    
    clrf 	PT5PU     
    clrf 	PT5CON
        
    clrf 	TM0CON    
    clrf 	TM2CON						;رնʱ/2 ΪIO    
    clrf 	TM3CON             			;رնʱ/3 ΪIO
                               	
    clrf 	WDTCON    					; رWDTʱΪ2048ms
    clrwdt                     	
    bsf 	MCK,5      					; رWDT
                               	
    clrf 	INTF      
    clrf 	INTF2     
    clrf 	INTE2     
    movlw 	10000010b
    movwf 	INTE     					; ⲿж1жʹ
                               			; رж                        
    sleep                      	
    nop            						; CPUִ˯ָеֱֹͣ   
	                           			;	һⲿжָλCPUΪ˱жϷ         
	                           			;	Interrupt Returnĳ󣬽ָֹ֮ͣ
	                           			;	һNOPָԱ֤ 
    	
;	call	Sub_clrram2                 ;   ˯߳¶оƬгʼãǵһЩ£         
										;	ݴ洢ݲ뱻£ﲻгʼãûԼҪ                   
Sub_Sleep_Exit:
	return                                            
;==============================================================	
;
;==============================================================	
TabStartAddr	dw	0c71h,0e38h			;2.5V,2.9V,λϵͳԶ䣬Ҫַʹorgд
//TabHeaderData .section ROM, addr=0x03f0	;дָĴ洢ַ
//TabStartAddr:
//	dw		0c71h,0e38h					;2.5V,2.9V
//.ends

;==============================================================	
;
;==============================================================	
.end
;============================================