include "CSU8RP3218.inc"
include	"define_const.inc"
;============================================
; interrupt function
;============================================
//INT_FUNCTION_sec .section rom	;
INT_FUNCTION:
	push							;workstatusĴջ
	

Sub_Int_EX0:	                   
	btfss	INTF,E0IF				;жǷΪⲿж0
	goto	Pro_Int_Ex1    
	bcf		INTF,E0IF				;ⲿж0 ־	
	goto	Sub_i_e0	
	
Pro_Int_Ex1:                      	;жǷΪⲿж1
	btfss	INTF,E1IF	
	goto	Sub_Int_Time0
	bcf		INTF,E1IF				;ⲿж1־
    goto    Sub_i_e1	
    		
Sub_Int_Time0:                    	;жǷΪʱ0ж     
	btfss	INTF,TM0IF	
	goto	Sub_Int_Time2
	bcf	  INTF,TM0IF				;㶨ʱ0жϱ־
	goto	Sub_i_t0		    
	
Sub_Int_Time2:                    	;жǷΪʱ2ж     
	btfss	INTF,TM2IF
	goto	Sub_Int_Time3
	bcf	    INTF,TM2IF				;㶨ʱ2жϱ־	
	goto	Sub_i_t2	
	
Sub_Int_Time3:                    	;жǷΪʱ3ж     
	btfss	INTF2,4					;tm3if
	goto	Sub_Int_Urt
	bcf	  INTF2,4					;㶨ʱ3жϱ־,tm3if
	goto	Sub_i_t3
	
Sub_Int_Urt:
	btfss	INTF3,URTIF		  		;жǷΪUARTж
	goto	Sub_Int_Urr             	
	bcf	  INTF3,URTIF	       		;UARTжϱ־
	goto	Sub_i_urt

Sub_Int_Urr:
	btfss	INTF3,URRIF				;жǷΪUARTж
	goto	Pro_Int_Exit               	
	bcf		INTF3,URRIF				;UARTжϱ־
	goto	Sub_i_urr

;============================================              
;Ӧ ⲿж0 жϺҪִеĶ                       
;============================================	           
Sub_i_e0:                                                      
                                                           
	goto	Pro_Int_Exit                                 
;============================================              
;Ӧ ⲿж1 жϺҪִеĶ                       
;============================================              
Sub_i_e1:                                                      
                                             
	goto	Pro_Int_Exit                                 
;============================================              
;Ӧ ʱ0 жϺҪִеĶ     
;ʱ0 ж 4ms     
;pt1.4 output: 1HZ  500msת1  125*4ms = 500ms  
;============================================              
Sub_i_t0:                                                      
    incf 	R_200ms_cnt,1	
    movlw 	50           		;ʱ200ms
	subwf 	R_200ms_cnt,0
	btfsc 	STATUS,C  
	bsf		R_flag,B_200ms   	;üʱ200ms־
   
    incf	R_Time_Cnt,1
	movlw	125					;ʱ500ms                                        
	subwf	R_Time_Cnt,0                                                          
	btfss	STATUS,C                                                               
	goto	Pro_Int_Exit                                                          
	                                                                              
	clrf	R_Time_Cnt                                                            
	movlw	00010000b			                                                  
	xorwf	led_port1,1			;ÿ500msתһpt1.4,LED0                        
                                                                                  
	movlw 	60					;ʱ30s                                          
	subwf 	R_10s1,0                                                              
	btfss  	STATUS,C                                                               
	goto 	Sub_count_addition                                                    
	                                                                              
	clrf 	TM3CON              ;30s                                            
	clrf	TM3CON2	            ;ػpwm3                                       
	bcf		R_flag,B_Time1      ;B_time1㣬رpwm2                        
	bsf		R_flag,B_Sleep		;30sģʽ
	goto	Pro_Int_Exit                                                          
	                                                                              
Sub_count_addition:                                                               
	incf 	R_10s1,1                                                              
	movlw	00000001b                                                             
    xorwf	R_flag,1    		;ÿ500msתһB_Time1־Ʒ       
	goto	Pro_Int_Exit                                                          
		
;============================================              
;Ӧ ʱ2 жϺҪִеĶ                         
;============================================              
Sub_i_t2:                                                      
	                                                       
	goto	Pro_Int_Exit                                 
;============================================              
;Ӧ ʱ3 жϺҪִеĶ                         
;============================================              
Sub_i_t3:                                                      
	                                                       
	goto	Pro_Int_Exit 
;============================================              
;Ӧ UART жϺҪִеĶ                         
;============================================	
Sub_i_urt:
	bsf			R_flag,B_urt				; λͱ־λ
	goto		Pro_Int_Exit
;============================================              
;Ӧ UART жϺҪִеĶ                         
;============================================
Sub_i_urr:
	bsf			R_flag,B_urr				; λձ־λ
	goto		Pro_Int_Exit                                
;============================================           				    		    
Sub_Non_Intrrupt:               	;жϱ־      	                  
;    clrf    intf	
;    clrf	intf2
    
Pro_Int_Exit:       
	pop								;workstatusĴջ
	retfie							;жϷ
;==============================================================	