include "CSU8RP3218.inc"
include "macro.inc"
;==============================================================   	
Pro_Sys_Init:
	call	Sub_Clock_Init
	call	Sub_Clrram0			;ͨݼĴ  	                                                                  
	call	Sub_IO_Init			;IOڳʼ                                  
	call	Sub_Time_Init       ;ʱʼ                                   
	call	Sub_AD_Init	    	;ADģʼ
	call	Sub_Uart_Init	    ;UARTģʼ                                          
	call	Sud_Int_Init        ;жϳʼ		
	                                                                 
	return                                                                                                   
;==============================================================   	
Sub_Clock_Init:
	clrf	STATUS				;״̬Ĵ
								;״̬Ĵϵ縴λֵΪxxu00000
								;Bit 7   	LVD363.6V LVDѹ־ֻеѡLVD_SELΪ2'b012'b10Ч
								;			1	ϵͳѹ3.6V˵͵ѹѴڼ״̬
								;			0	ϵͳѹ3.6V͵ѹûй
		
								;Bit 6		LVD242.4V LVDѹ־ֻеѡLVD_SELΪ2'b01Ч
								;			1 ϵͳѹ2.4V˵͵ѹѴڼ״̬
								;			0 ϵͳѹ2.4V͵ѹûй
								        	
								;Bit 4		PD־λͨԴλд0㣬sleepôλ
								;			1 ִSLEEPָ
								;			0 ϵ縴λӲλCLRWDTָ֮
								        	
								;Bit 3		TOŹʱ־ͨԴλд0㣬Źʱôλ
								;			1 Źʱ
								;			0 ϵ縴λӲλCLRWDTָSLEEPָ
								        	
								;Bit 2		DCֽڽλ־/λ־(ڽλʱ෴)
								;			1 ĵ4λֽλ
								;			0 ĵ4λֽλ
								        	
								;Bit 1		Cλ־/λ־(ڽλʱ෴)
								;			1λMSBֽλ
								;			0λMSBֽλ
								        	
								;Bit 0		Z־
								;			1߼ǽΪ0
								;			0߼ǽΪ0				
	                         
	movlw	10000000b
	movwf	MCK    				;ڲ,ڲWDT
								;mckϵ縴λֵΪ1010uuu0
								;bit7(CST)   ⲿ   
								;			1ⲿر
								;			0ⲿ
											
								;bit6(CST_IN): ڲ   
								;			1ڲر   
								;			0ڲ
		
								;Bit5(CST_WDT)ڲWDT
								;			1ڲWDTر
								;			0ڲWDT
		
								;bit4(EO_SLP): ⲿپλ 
								;			1ѡⲿپ32768Hzsleepģʽ²رⲿ
								;			0sleepģʽ¹رⲿ
											
								;bit0(CLKSEL):ʱԴѡλ(CPUʱ)
								;			1:ⲿϵͳʱ
								;			0:ڲϵͳʱ
							
	movlw	11111111b
	movwf	WDTIN				;wdtin(ϵ縴λֵΪ11111111)

	movlw	10000001b
	movwf	WDTCON				;ʹܿŹ1.024sλ	
								;wdtconϵ縴λֵΪ0uuuu000	
							 	
							 	;Bit7		wdtenŹʹλ; 
	
							 	;Bit[2-0]	wdtswdtinΪ11111111bʱ
								;			000   ʱΪ 2048ms
								;			001   ʱΪ 1024ms
								;			010   ʱΪ 512ms
								;			011   ʱΪ 256ms
								;			100   ʱΪ 128ms
								;			101   ʱΪ 64ms
								;			110   ʱΪ 32ms
								;			111   ʱΪ 16ms

	return
;=============================================================
; ּͨĴ
;=============================================================	
Sub_Clrram0:		        	;ּͨĴ80h-FFh
	movlw	80h		 
	movwf	FSR0				;fsr0 еֵΪַȥݴ洢õ
clrram0_loop:	
    clrf	IND0    	  		
	incfsz	FSR0,1 
	goto	clrram0_loop    	

	return
;=============================================================
; IOڳʼ                   
;=============================================================
Sub_IO_Init:	
	clrf	PT1					;GPIO 1ݱ־λ	pt1[7:1]ϵ縴λֵxxxxxxxu

	movlw	00110000b  			
	movwf	PT1EN      			;GPIO 1/Ʊ־
								;pt1en[7:1]ϵ縴λֵΪ0000000u
								;Bit 7		pt1.7I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
		
								;Bit 6		pt1.6I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
		
								;Bit 5		pt1.5I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
								        	
								;Bit 4		pt1.4I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
								        	
								;Bit 3		pt1.3I/OƱ־λ
								;			0 = ΪڣֻΪڣֻ

								;Bit 2		pt1.2I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
								        	
								;Bit 1		pt1.1I/OƱ־λ
								;			0 = Ϊ
								;			1 = Ϊ
								        									
	movlw	00000000b  				    
	movwf	PT1PU      			;GPIO 1ʹܱ־
								;pt1pu[7:1]ϵ縴λֵΪ0000000u
								;Bit 7		pt1.7 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ
								        	
								;Bit 6		pt1.6 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ
								        	
								;Bit 5		pt1.5 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ
								        	
								;Bit 4		pt1.4 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ
								        	
								;Bit 3		pt1.3 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ    
								        	
								;Bit 2		pt1.2 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ
								        	
								;Bit 1		pt1.1 Ʊ־λ
								;			0 = Ͽ
								;			1 = ʹ  
	                    			       
	movlw	00000001b			
	movwf	PT1CON   			;ⲿж1ⲿж0
								;pt1con[7:0]ϵ縴λֵΪ00000000
								;Bit 7 		PT11ODPT1.1©·ʹλ
								; 			0 = ֹPT1.1©·
								; 			1 = ʹPT1.1©·
								        	
								;Bit 6 		PT1W[3]:PT1.5ⲿж1ʹ
								; 			0 = ֹPT1.5ⲿж1
								; 			1 = ʹPT1.5ⲿж1
								       		
								;Bit 5 		PT1W[2]:PT1.4ⲿж1ʹ
								; 			0 = ֹPT1.4ⲿж1
								; 			1 = ʹPT1.4ⲿж1
								       		
								;Bit 4 		PT1W[1]:PT1.3ⲿж1ʹ
								; 			0 = ֹPT1.3ⲿж1
								; 			1 = ʹPT1.3ⲿж1
								       		
								;Bit 3 		PT1W[0]:PT1.1ⲿж1ʹ
								; 			0 = ֹPT1.1ⲿж1
								; 			1 = ʹPT1.1ⲿж1
								       		
								;Bit 2 		E1Mⲿж1ģʽ
								; 			1 = ⲿж1Ϊ½ش
								; 			0 = ⲿж1״̬ıʱ
								
								;Bit 1:0 	E0M[1:0]ⲿж0ģʽ
								; 			11 = ⲿж0״̬ıʱ
								; 			10 = ⲿж0״̬ıʱ
								; 			01 = ⲿж0Ϊش
								; 			00 = ⲿж0Ϊ½ش
		
	movlw	00000000b
	movwf	PT1CON1				;ⲿж1ⲿж0
								;pt1con1[4:0]ϵ縴λֵΪuuuu0000
								;bit 3 PT1W2[3]:PT3.1ⲿж1ʹ
								;			0 = ֹPT3.1ⲿж1
								;			1 = ʹPT3.1ⲿж1
		
								;bit 2 PT1W2[2]:PT1.7ⲿж1ʹ
								;			0 = ֹPT1.7ⲿж1
								;			1 = ʹPT1.7ⲿж1
		
								;bit 1 PT1W2[1]:PT1.6ⲿж1ʹ
								;			0 = ֹPT1.6ⲿж1
								;			1 = ʹPT1.6ⲿж1
		
								;bit 0 PT1W2[0]:PT1.2ⲿж1ʹ
								;			0 = ֹPT1.2ⲿж1
								;			1 = ʹPT1.2ⲿж1
		
	clrf	PT3					;GPIO 3ݱ־λ	pt3[7:0]ϵ縴λֵxxxxxxxx
		
	movlw	01100101b  	
	movwf	PT3EN      			;GPIO 3/Ʊ־
								;pt3en[7:0]ϵ縴λֵΪ00000000
								;			0 = Ϊڣ1 = Ϊ
		  
	movlf	00000000b,PT3PU      	  		;GPIO 3ʹܱ־	
								;PT3PU[7:0]ϵ縴λֵΪ00000000
								;			0 = Ͽ裬1 = ʹ

	clrf	PT3CON 				;GPIO 3ģ/ֶ˿ʹܱ־
								;pt3con[7:0]ϵ縴λֵΪ00000000                               
	    	                    ;			0 = Ϊֿڣ1 = Ϊģ
   
	clrf	PT5					;GPIO5ݱ־λ	PT5[2:0]ϵ縴λֵΪuuuuuxxx
	                           
	movlw	00000001b           
	movwf	PT5EN				;GPIO 5/Ʊ־	
								;PT5EN[2:0]ϵ縴λֵΪuuuuuxxx                                
	                            ;			0 = Ϊڣ1 = Ϊ

	clrf	PT5PU 	    		;GPIO 5ʹܱ־	
								;PT5PU[2:0]ϵ縴λֵΪuuuuuxxx                                  
	                            ;			0 = Ͽ裬1 = ʹ
	      		
	clrf	PT5CON   			;pt5.0pt5.1pt5.2ֹ©		
								;pt5con[2:0]ϵ縴λֵΪuuuuuxxx                                          
								;Bit 2		PT51ODpt5.1 Ʊ־λ	
								;			0 = ֹ©1 = ʹܿ©
								;Bit 1		PT50ODpt5.0 Ʊ־λ	
								;			0 = ֹ©1 = ʹܿ©
								;Bit 0		PT5CON0pt5.0 Ʊ־λ
								;			0 = Ϊֿڣ1 = Ϊģ

;	clrf 	metch				;bit 0		P13OD: PT1.3©ʹ
	                            ;           0ΪΪ         
	                            ;           1©0            
	                            ;          	ע©ʱⲿ1P13ODΪ0IOΪߵƽ
	                            ;										P13ODΪ1IOΪ͵ƽ
	
	
	return		                            
;=============================================================
; ʱʼ                              
;=============================================================
Sub_Time_Init:	
	movlw	11110000b 	 
	movwf	TM0CON    	 		;öʱ0˴t0rate=cpu/128=4M/128=31.25K	=32us
						 		;tm0conϵ縴λֵΪ0000u100
						 		;Bit 7  	t0en  ʱ0ʹλ
						 		;			1ʹܶʱ0
						 		;	  		0ֹʱ0
						 		
						 		;Bit[6:4] 	t0rate[2:0]		ʱ0ʱѡ
             			 		;			t0rate [2:0]     tm0clk
						 		;			000		         ckt0
						 		;	 		001				 ckt0 /2
						 		;			010				 ckt0 /4
						 		;			011				 ckt0 /8
						 		;			100				 ckt0 /16
						 		;			101				 ckt0 /32
						 		;			110				 ckt0 /64
					 	 		;			111				 ckt0 /128
					 	 		
						 		;Bit 2 		t0rstb	ʱ0λ
						 		;			1ֹʱ0λ
						 		;			0ʹܶʱ0λλΪ0ʱʱ0λT0RSTBԶ1
						 		
						 		;Bit[1:0]	t0sel[1:0]	ʱԴѡ
						 		;			t0sel[1:0]	ʱ0ʱԴ
						 		;			00          cpuclk
						 		;			01			mck
						 		;			1x			ڲ32K wdtʱӣڲwdtʱЧ

	
	movlw	124      	 
	movwf	TM0IN     	 		;tm0ʱΪ 32us*(124+1)=4ms	
								;ʱ0ʱ㷽
	                            ;	ʱ0ʱ=(tm0in+1)/tm0clk
	                            
	clrf	TM0CNT		 		;嶨ʱ0Ĵֻ
;--------------------------------------------      
;ʱ/2ʼ                                
;--------------------------------------------
    movlw 	00000000b
    movwf 	TM2CON   			;öʱ2                                                 
                                ;tm2conϵ縴λֵΪ00000100                                                 
						        ;Bit 7 		t2en 	ʱ/2ʹλ                                           
						        ;       	1ʹܶʱ2                                                   
						        ;       	0ֹʱ2                                                   
						                                                                                 
						        ;Bit[6:4] 	t2rate[2:0] 	ʱ/2ʱѡ                                
						        ;			t2rate [2:0]	tm2clk	(CKT2ʱԴѡTMCON2Ĵt2sel[1:0]λ)               
						        ;			000				ckt2                                                
						        ;			001				ckt2 /2                                             
						        ;			010				ckt2 /4                                             
						        ;			011				ckt2 /8                                             
						        ;			100				ckt2 /16                                            
						        ;			101				ckt2 /32                                            
						        ;			110				ckt2 /64                                            
						        ;			111				ckt2 /128                                                                       
						                                                                                 
						        ;Bit 3 		t2cks	ʱ/2ʱԴѡλ                                    
						        ;			1pt1.0Ϊʱ                                                        
						        ;			0cpuclkmckķƵʱ                                
						                                                                                 
						        ;Bit 2 		t2rstb 	ʱ/2λ         
						        ;			1ֹʱ/2λ                                                 
						        ;			0ʹܶʱ/2λλΪ0ʱʱ2λt2rstbԶ1  
						                                                                                 
						        ;Bit 1:0  	t2out pwm2out 	pt1.4ƣpt1.4ΪʱЧ                               
						        ;			0	 	0	 	IO                                        
						        ;		 	0		1		PWM2                                     
						        ;			1		0		                                    
						        ;			1		1		PWM2                                      
							
	clrf 	TM2IN  				
    clrf 	TM2INH 				;嶨ʱ/2ֵ
    							;ʱ2ʱ㷽
                                ; 	ʱ2ʱ=tm2in[11:0]+1/tm2clk tm2inΪ0
    
    clrf 	TM2R   				
    clrf 	TM2RH  				;嶨ʱ/2PWMߵƽռձȿƼĴ
 
    clrf 	TM2CNT 
    clrf 	TM2CNTH				;嶨ʱ/2Ĵ																	 				
;--------------------------------------------      
;ʱ/4ʼ                                
;--------------------------------------------
    movlw 	10000000b
    movwf 	TM4CON   			;öʱ4˴t4rate=cpu=4M                                                
                                ;tm4conϵ縴λֵΪ00000100                                                 
						        ;Bit 7 		t4en 	ʱ/4ʹλ                                           
						        ;       	1ʹܶʱ4                                                   
						        ;       	0ֹʱ4                                                  
						                                                                                 
						        ;Bit[6:4] 	t4rate[2:0] 	ʱ/4ʱѡ                                
						        ;			t4rate [2:0]	tm4clk	(CKT4ʱԴѡTMCON2Ĵt4sel[1:0]λ)               
						        ;			000				ckt4                                                
						        ;			001				ckt4 /2                                             
						        ;			010				ckt4 /4                                             
						        ;			011				ckt4 /8                                             
						        ;			100				ckt4 /16                                            
						        ;			101				ckt4 /32                                            
						        ;			110				ckt4 /64                                            
						        ;			111				ckt4 /128                                                                       
						                                                                                 
						        ;Bit 3 		t4cks	ʱ/4ʱԴѡλ                                    
						        ;			1pt1.0Ϊʱ                                                        
						        ;			0cpuclkmckķƵʱ                                
						                                                                                 
						        ;Bit 2 		t4rstb 	ʱ/4λ         
						        ;			1ֹʱ/4λ                                                 
						        ;			0ʹܶʱ/4λλΪ0ʱʱ4λt4rstbԶ1  
						                                                                                 
						        ;Bit 1:0  	t4out pwm4out 	pt1.6ƣpt1.6ΪʱЧ                               
						        ;			0	 	0	 	IO                                        
						        ;		 	0		1		PWM4                                       
						        ;			1		0		                                   
						        ;			1		1		PWM4                                      
	
	movlw	25						
	movwf 	TM4IN  				
    clrf 	TM4INH 				;tm4Ϊ tm4clk/(tm4in[11:0]+1)= 4M/(25+1)= 153.8k
    							;ʱ4ʱ㷽
                                ; 	ʱ4ʱ=tm4in[11:0]+1/tm4clk tm4inΪ0
    
    clrf 	TM4R   				
    clrf 	TM4RH  				;嶨ʱ/4PWMߵƽռձȿƼĴ
              
    clrf 	TM4CNT 
    clrf 	TM4CNTH				;嶨ʱ/4Ĵ
;--------------------------------------------      
;ʱ/3ʼ                                
;--------------------------------------------
    movlw 	00000000b
    movwf 	TM3CON   			;öʱ3                                                 
                                ;tm3conϵ縴λֵΪ00000100                                                 
						        ;Bit 7 		t3en 	ʱ/3ʹλ                                           
						        ;       	1ʹܶʱ3                                                   
						        ;       	0ֹʱ3                                                   
						                                                                                 
						        ;Bit[6:4] 	t3rate[2:0] 	ʱ/3ʱѡ                                
						        ;			t3rate [2:0]	tm3clk	(CKT3ʱԴѡTMCON2Ĵt3sel[1:0]λ)               
						        ;			000				ckt3                                                
						        ;			001				ckt3 /2                                             
						        ;			010				ckt3 /4                                             
						        ;			011				ckt3 /8                                             
						        ;			100				ckt3 /16                                            
						        ;			101				ckt3 /32                                            
						        ;			110				ckt3 /64                                            
						        ;			111				ckt3 /128                                                                       
						                                                                                 
						        ;Bit 3 		t3cks	ʱ/3ʱԴѡλ                                    
						        ;			1pt1.1Ϊʱ                                                        
						        ;			0cpuclkmckķƵʱ                                
						                                                                                 
						        ;Bit 2 		t3rstb 	ʱ/3λ         
						        ;			1ֹʱ/3λ                                                 
						        ;			0ʹܶʱ/3λλΪ0ʱʱ3λt2rstbԶ1  
						                                                                                 
						        ;Bit 1:0  	t3out pwm3out 	pt1.5ƣpt1.5ΪʱЧͬʱδʹܻPWM                               
						        ;			0	 	0	 	IO                                        
						        ;		 	0		1		PWM3                                     
						        ;			1		0		                                     
						        ;			1		1		PWM3                                      
							
	clrf 	TM3IN  				
    clrf 	TM3INH 				;嶨ʱ/3ֵ
    							;ʱ3ʱ㷽
                                ; 	ʱ3ʱ=tm3in[11:0]+1/tm3clk tm3inΪ0
    
    clrf 	TM3R   				
    clrf 	TM3RH  				;嶨ʱ/3PWMߵƽռձȿƼĴ
 
    clrf 	TM3CNT 
    clrf 	TM3CNTH				;嶨ʱ/3Ĵ
											
	clrf    TM3CON2   			;ʱ
								;tm3con2ϵ縴λֵΪ00000000
								;Bit[7:6]	dt3ck[1:0]	ʱ3ʱʱѡ
								;			dt3ck[1:0]	dt3_clk   
								;			00       	mck       
								;			01       	mck/2     
								;			10       	mck/4     
								;			11       	mck/8     
								
								;Bit[5:3]	dt3cnt[2:0]	ʱѡ
								;                        ʱ=dt3cnt[2:0]*(1/dt3_clk)
								                        
								;Bit 2		dt3_en		3ʹλ                           
								;           0ʹ3
								;           1ʹ3  
								
								;Bit 1 		p3h_oen		PWM3Hʹ
								;           0PWM3H   
								;           1PWM3HPT3.6
								
								;Bit 0		p3l_oen		PWM3Lʹ
								;           0PWM3L   
								;           1PWM3LPT3.5
	
	movlw	00000011b			;ûpwm3hpwm3l,pwm (ϵĬֵ00uuu000)
	movwf	TMCON				;bit 7		p3hinv	PWM3Hȡλ 
								; 			0PWM3Hȡ
								; 			1PWM3Hȡ
								
								;bit 6		p3linv	PWM3Lȡλ
								;			0PWM3Lȡ
								;			1PWM3Lȡ
								
								;bit 2		pwm4po	PWM4ѡ
								;			0PT1.6ΪPWM4
								;			1PT3.6ΪPWM4
								
								;bit 1		pwm3po	PWM3ѡ
								;			0PT1.5ΪPWM3
								;			1PT3.5ΪPWM3
								
								;bit 0		pwm2po	PWM2ѡ
								;			0PT1.4ΪPWM2
								;			1PT5.0ΪPWM2
								
	movlw	00000100b			
	movwf	TMCON2				;ʱʱѡ;(ϵĬֵuu000000)   
								;bit [5:4]	t4sel[1:0]	ʱ4ʱԴѡ
								;			t4sel[1:0]	ʱ4ʱԴ
								;			00			CPUCLK
								;			01			MCK
								;			1x			ⲿʱECK(ⲿⲿҾʱЧ)

								;bit [3:2]	t3sel[1:0]	ʱ3ʱԴѡ
								;			t3sel[1:0]	ʱ3ʱԴ
								;			00			CPUCLK
								;			01			MCK
								;			1x			ⲿʱECK(ⲿⲿҾʱЧ)
								
								;bit [1:0]	t2sel[1:0]	ʱ2ʱԴѡ
								;			t2sel[1:0]	ʱ2ʱԴ(CKT2)
								;			00			CPUCLK
								;			01			MCK
								;			1x			ⲿʱECK(ⲿⲿҾʱЧ)
							
	return                                           	
;=============================================================
; ADʼ
;=============================================================
Sub_AD_Init:
	movlw	00000001b   		      
	movwf	SRADCON0;sradcon0    		;ADCźŵĻȡʱ
								;B1:B0 = 01		ADC CLOCK = CPUCLK/2=4M/2=2M  
								;B5:B4 = 00     תʱԼ14us  
								;sradcon0ϵ縴λֵΪuu00uu00          
								;Bit[5:4]	sradacks[1:0] 	ADCźŻȡʱ     
								;			00				16ADCʱ             
								;			01				 8ADCʱ             
								;			10				 4ADCʱ             
								;			11				 2ADCʱ             
								                                               
								;Bit[1:0]	sradcks[1:0] 	ADCʱ                  
								;			00				CPUCLK                          
								;			01				CPUCLK/2                        
								;			10				CPUCLK/4                        
								;			11				CPUCLK/8                        
	                    		                                                
	movlw	00000000b   		
	movwf	SRADCON1;sradcon1    		;ADCת	B[1:0]10 ڲ1.4Vο
	                    		;sradcon1ϵ縴λֵΪ00000000
								;Bit 7		sraden 		ADCʹλ
								;			1ʹ, 0ֹ
								
								;Bit 6 		srads 		ADCλ/״̬λ
								;			1ʼת 
								;			0ֹͣת
								;			λADCתתɻԶ0
								
								;Bit 5 		often 		תѡλ
								;			1תsroftĴ
								;			0תsradĴ
								
								;Bit 4 		calif 		Уλ(oftenΪ0ʱЧ)
								;			1ʹУADתĽǼȥsroftʧѹֵ
								;			0ֹУADתûмȥsroftʧѹֵ
								
								;Bit 3 		enov 		ʹܱȽģʽ(califΪ1ʱЧ)
								;			1ʹܣֱǼȥĽ
								;			0ֹΪ000hΪfffh
								
								;Bit 2 		offex 		offset
								;			1ȽźŽ
								;			0ȽźŲΪźţΪοѹ
								
								;Bit[1:0]	vrefs[1:0] 	ADCοԴѡ 
								;			(עͬοѹлӳ10uSADת)
								;			vrefs[1:0]		ADοѹ
								;			00				VDD
								;			01				PT3.0ⲿοԴ
								;			10				ڲοѹοѹsradcon2ĴУ
								;			11				ڲοѹPT3.0ӵΪòοѹ˲ʹã߾ȡ
                        		
	movlw	00000000b
	movwf	SRADCON2;sradcon2			;ADCͨ	B[1:0]10 ڲ1.4Vο
								;sradcon2ϵ縴λֵΪ0000uuuu
								;bit [7:4]	chs[3:0]	ADCͨѡλ
								;			0000		AIN0
								;			0001		AIN1
								;			0010		AIN2
								;			0011		AIN3
								;			0100		AIN4
								;			0101		AIN5
								;			0110		AIN6
								;			0111		AIN7
								;			1000		AIN8
								;			1001		AIN9룬ڲ1/8VDD
								;			1010		AIN10룬ڲοѹ
								;			1011		AIN11룬ڲӵ
								;					ڶ
									
								;bit [1:0]	ref_sel[1:0]	ڲοѹ
								;			00				1.4V
								;			01				2.0V
								;			10				3.0V
								;			11				4.0V
	
;	clrf 	metch				;bit 5   	REFOEN     	ڲοѹPT3.0ʹλREF_SEL[1:0]ѡڲοѹ                                                      
	                            ;			0ֹڲοѹ                                          
	                            ;			1ʹڲοѹ                                          
	                            ;				עVREFS[1:0]Ϊ01ʱֹREFOENΪ1                          
	                            ;bit 4   	REFIN      	VREFS[1:0]ͬѡⲿοѹVREFS[1:0]Ĵ                                                       
	                            ;				PT3.2ⲿοѹSAR_ADCοѹ뽫PT3CON[2]1ģ   
				
	return                      
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; ʼUART                
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sub_Uart_Init:
	movlw 	01010000b				;SCON1:(ϵĬֵλ:000000uu)
	movwf	SCON1;scon1 					;Bit7-6 SM0 SM1: ͨŹʽ
									;		 ʽ      
									;		00 = 0      ͬ   BaudRate = Fcpuclk/6
									;		01 = 1      첽   
									;						   TM4/16(SMOD=1)
									;						   TM4/32(SMOD=0)
									;		10 = 2		첽   Fcpuclk/16(SMOD=0)
									;						   Fcpuclk/32(SMOD=1)
									;		11 = 3		첽  
									;					   		TM4/16(SMOD=1)
									;					   		TM4/32(SMOD=0)
									
									;Bit5   SM2: 
									;
									;Bit4   REN: տѡ
									;	1 = 
									;   0 = ֹ
									
									;Bit3   TB8: ݵ9λ
									;
									;Bit2   RB8: ݵ9λ
									
	
	movlw 	11101111b				;SCON2:(ϵĬֵ:000u0000)
	movwf	SCON2;scon2 					;Bit7   SMOD: ѡĴ
									;		0ʱ0/2/3/432
									;		1ʱ0/2/3/416
									;bit[6:5]	URCLK[1:0]	UARTʱѡλ
									;			URCLK [1:0]		UARTʱ
									;          00   		ѡʱ0Ϊʱӣ  
									;                       SMOD=1Ϊ/16
									;                       SMOD=0Ϊ/32  
									;          01          ѡʱ2Ϊʱӣ     
									;                       SMOD=1Ϊ/16 
									;                       SMOD=0Ϊ/32   
									;			10			ѡʱ3Ϊʱӣ   
									;                       SMOD=1Ϊ/16  
									;                       SMOD=0Ϊ/32   
									;			11			ѡʱ4Ϊʱӣ  
									;                       SMOD=1Ϊ/16
									;                       SMOD=0Ϊ/32
									   
									;bit 3		UARTEN		UARTģʹ                
									;         	0ʹUARTģ                           
									;          1ʹUARTģ                             
									;          رUARTģʹλ򲻻жϱ־λ
									
									;bit[2:0]  PINCTL[2:0] UARTͨſѡ                                                                  
									;          3b000      PT1.1PT1.2ͨIOڣPT3.3PT3.4ͨIO                                                 
									;          3b001      PT1.1UARTͨſڣPT1EN[1]PT1.2ͨIOڣPT3.3PT3.4ͨIO                                                                                                                             
									;          3b010      PT1.2UARTͨſڣPT1EN[2]PT1.1ͨIOڣPT3.3PT3.4ͨIO                                               
									;          3b011      PT1.1PT1.2ֱUARTͨſRITI PT3.3PT3.4ͨIO                        
									;          3b100      PT1.1PT1.2ͨIOڣPT3.3PT3.4ͨIO                                     
									;          3b101      PT3.3UARTͨſڣPT3EN[3]PT3.4ͨIOڣPT1.1PT1.2ͨIO     
									;          3b110      PT3.4UARTͨſڣPT3EN[4]PT3.3ͨIOڣPT1.1PT1.2ͨIO     
									;          3b111      PT3.3PT3.4ֱUARTͨſRITI PT1.1PT1.2ͨIO                        
									;          	ѡͬͨŻͬʱҪзͺͽʱΪͨſڣ
									;          	PINCTL[2:0]Ϊ3bx11PINCTL[2:0]Ϊ3bx013bx10ʱ
									;          	ʱֻһͨſʹãʱͨſڿԷʱΪRITI
									;          	IOڵķλƣ磺PINCTL[2:0]Ϊ3b001ʱ
									;          	ʱֻPT1.1UARTͨſڣPT1EN[1]Ϊ0ʱPT1ΪRIڣPT1EN[1]Ϊ1ʱPT1ΪTIڡ											
	
	clrf	SBUF;sbuf 					;崮ݼĴ	
	return
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; жϳʼ                    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sud_Int_Init:                                                            
	clrf	INTF;intf       	 		;жϱ־
								;intfϵ縴λֵΪu0u00u00
								;Bit 6 		tm2if		12-Bitʱ/2жϱ־㣬Ӳø
								;			1 = ʱжϣ0                               
								;			0 = ûʱж  
								                                       
								;Bit 4 		tm0if		8-Bitʱ0жϱ־㣬Ӳø      
								;			1 = ʱжϣ0                              
								;			0 = ûʱж       
								                                   
								;Bit 3 		sradif		ADжжϱ־㣬Ӳø            
								;			1 = ADжϣ0                                
								;			0 = ûADж   
								                                        
								;Bit 1 		e1if		ⲿж1жϱ־㣬Ӳø           
								;			1 =ⲿж1жϣ0                           
								;			0 =ⲿж1ûж                                     
								
								;Bit 0 		e0if		ⲿж0жϱ־㣬Ӳø          
								;			1 = ⲿж0жϣ0                          
								;			0 =ⲿж0ûж                                     
											    
	clrf	INTF2;intf2				;жϱ־
								;intf2ϵ縴λֵΪuuu0uuuu
								;Bit 5 		tm4if		12-Bitʱ/4жϱ־㣬Ӳø
                                ;			1 = ʱжϣ0                              
	      	                    ;			0 = ûʱж    
	
								;Bit 4 		tm3if		12-Bitʱ/3жϱ־㣬Ӳø
                                ;			1 = ʱжϣ0                              
	      	                    ;			0 = ûʱж                                         

	clrf    INTF3;intf3  	    		;жϱ־
								;inte3ϵ縴λֵΪ0uuuuu00
								;Bit 7 		cmpif	Ƚжϱ־	
								;Bit 1 		urtif	UARTͨŷжϱ־
								;Bit 0 		urrif	UARTͨŽжϱ־       	          
	      	          
	movlw	10010000b
	movwf	INTE;inte   				;жʹܡTM0жʹܡⲿж0ʹ
								;inteϵ縴λֵΪ00u00u00 
								;Bit 7 		gie			ȫжʹܱ־                
			         	     	;			1 = ʹзж                     
			         	     	;			0 = ʹж 
			         	     	                        
			         	     	;Bit 6 		tm2ie		12-Bitʱ/2жʹܱ־
			         	     	;			1 = ʹܶʱ/2ж                   
			         	     	;			0 = ʹܶʱ/2ж  
			         	     	               
			         	     	;Bit 4 		tm0ie		8-Bitʱ0жʹܱ־      
			         	     	;			1 = ʹܶʱ0ж                        
			         	     	;			0 = ʹܶʱ0ж                      
			         	     	
			         	     	;Bit 3 		sradie		ADжʹܱ־               
			         	     	;			1 = ʹADж                             
			         	     	;			0 = ʹADж                           
			         	     	
			         	     	;Bit 1 		e1ie		ⲿж1ʹܱ־              
			         	     	;			1 =ʹⲿж1                           
			         	     	;			0 = ʹⲿж1                        
			         	     	
			         	     	;Bit 0 		e0ie		ⲿж0ʹܱ־              
			         	     	;			1 = ʹⲿж0                          
			         	     	;			0 = ʹⲿж0                        
			         	     				         	     	
	clrf    INTE2;inte2  	    		;رնʱ3,4жʹ
								;inte2ϵ縴λֵΪuu00uuuu
								;Bit 5 		tm4ie		12-Bitʱ/4жʹܱ־
								;			1 = ʹܶʱ/4ж
								;			0 = ʹܶʱ/4ж
	
								;Bit 4 		tm3ie		12-Bitʱ/3жʹܱ־
								;			1 = ʹܶʱ/3ж
								;			0 = ʹܶʱ/3ж
	
	clrf	INTE3;inte3				;رնʱ3жʹ
								;inte3ϵ縴λֵΪ0uuuuu00
								;Bit 7 		cmpie	Ƚжʹ
								;			1 = ʹܱȽж
								;			0 = ֹȽж
	
								;Bit 1 		urtie	UARTķжʹ
								;			1 = ʹUARTķж    
								;			0 = ֹUARTķж   
								
								;Bit 0 		urrie	UARTĽжʹ 
								;			1 = ʹUARTĽж      
		       	                ;			0 = ֹUARTĽж     
	return	